<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>

    <title>Panel</title>

    <style>
        div {
            display: inline-block;
            margin: 0px 30px;
        }
        table {
            display: inline-block;
            vertical-align: top;
            width: 200px;
            margin: 0px 30px;
        }
        tr:hover {
            background-color: bisque;
            cursor: pointer;
        }
        td {
            border: 1px solid black;
            padding: 5px;
        }
    </style>
</head>
<body>
    <h1>Panel</h1>
    <p>Narucivanje: izborom kategorije preko API dovlaci njene proizvode. Klik na neki iz tabele formira tabelu za narucivanje. 'Naruci' salje API sa podacima racuna i upisuje ga u bazu.</p>

    <table>
    {% for x in categories %}
    <tr data-cat_id="{{ x.id }}">
        <td>{{ x.id }}</td>
        <td>{{ x.cat }}</td>
        <td><img src="/media/{{ x.cat_image }}" height="60"></td>
    </tr>
    {% endfor %}
    </table>

    <table><tbody id="articles"></tbody> </table>
    <table><tbody id="narudzbina"></tbody> </table>

    <div>
        <h4>Sto broj: <span id="sto_broj">1</span></h4>
        <h2>Ukupno: <span id="ukupno">0.00</span></h2>
        <button id="naruci">Naruci</button>
    </div>

    <p id="info"></p>

    <script>
        $(document).ready(function(){
            $('#sto_broj').text(Math.floor((Math.random() * 100) + 1));

            $(document.body)
                .on('click', '#articles tr', function(){
                    $(this).clone().appendTo('#narudzbina');
                    ukupno = 0;
                    $('#narudzbina tr').each(function(){
                        ukupno += parseFloat($(this).children(':nth-child(3)').text());
                    })
                    $('#ukupno').text(ukupno.toFixed(2));
                })
                .on('click', '#narudzbina tr', function(){
                    $(this).remove();
                    ukupno = 0;
                    $('#narudzbina tr').each(function(){
                        ukupno += parseFloat($(this).children(':nth-child(3)').text());
                    })
                    $('#ukupno').text(ukupno.toFixed(2));
                });

            $('tr').click(function(){
                $('tr').css('color', 'black');
                $(this).css('color', 'blue');

                $.ajax({
                    url: "/api/catarticles/" + $(this).data('cat_id'),
                    success: function (response) {
                        $('#articles').html('');
                        $.each(response, function(index, d) {
                            $('#articles').append('<tr><td>' + d.id + '</td><td>'  + d.art + '</td><td>' + d.price + '</td></tr>');
                        });
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        $('#info').html(JSON.stringify(jqXHR.responseText));
                    }
                });
            })

            $('#naruci').click(function(){
                stavke = [];
                $('#narudzbina tr').each(function(){
                    stavke.push(parseInt($(this).children(':nth-child(1)').text()));
                });

                racun = {
                    sto: $('#sto_broj').text(),
                    ukupno: $('#ukupno').text(),
                    stavke: stavke
                };

                $.ajax({
                    url: "/api/racun",
                    type: "POST",
                    data: JSON.stringify(racun),
                    contentType: "application/json;charset=utf-8",
                    beforeSend: function(xhr, settings) {
                        xhr.setRequestHeader("X-CSRFToken", '{{ csrf_token }}');
                    },
                    success: function (response) {
                        $('#info').text(JSON.stringify(response));
                        $('#sto_broj').text(Math.floor((Math.random() * 100) + 1));
                        $('#narudzbina').html('');
                        $('#articles').html('');
                        $('#ukupno').text('0.00');
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        $('#info').html(JSON.stringify(jqXHR.responseText));
                    }
                });

            })

        });
    </script>
</body>
</html>